
// ******************** RK NOG'S DMF DISKCOPY PROGRAM *******************
//
//							COPIES 80 TRACKS @ 21 SECTORS PER TRACK
//									1.716224 MEGABYTE DISK
//												ONTO
//						   		1.745408 MEGABYTE DISK
//							82 TRACKS @ 21 SECTORS PER TRACK
//
//											Comments
//
//		A.	To copy a Windows 95 disk you have to read and write the boot
//		sector last because it has 4 sectors per cluster.
//
//		B.	Only one header file is used.
//
// ************************************************************************

#include <stdio.h>   						// for getc, printf, FILE

// ****************************** PROTOTYPES ******************************
 int position_cursor(int row, int collumn);
 int set_color(int roak_color);
 int get_sectors_per_cluster(void);
 int get_total_number_of_sectors(void);

// ******************************* FUNCTIONS ******************************
// SET CURSOR POSITION
int position_cursor(int row, int collumn){
	__asm{
	mov AH, 02h								// function number
	mov BH, 00h								// video page
	mov DH, BYTE PTR row					// row
	mov DL, BYTE PTR collumn			    // collumn
	int 10h									// interrupt call
	}return 0;}


// IMPROVE VIDEO AND CHANGE BACKGROUND AND FONT COLOR
int set_color(int roak_color){
	__asm{
	mov AH, 09h								// function number
	mov CX, 2000							// number of characters of output
	mov BL, BYTE PTR roak_color	        	// color code
	mov AL, " "								// blank characters
	int 10h									// call interrupt
	}return 0;}

// GET SECTORS PER CLUSTER
int get_sectors_per_cluster(){
	unsigned char buffy[512];
    int counter = 0;
	for(counter = 0; counter < 5; counter++){
	__asm{
	mov AH, 02h								// read sector function
	mov AL, 01h								// number of sectors to read
	mov CH, 00h								// track
	mov CL, 01h								// sector
	mov DH, 00h								// side
	mov DL, 00h								// drive
	LEA BX, buffy
	int 13h
	}}return (int)buffy[13];}

// GET TOTAL NUMBER OF SECTORS
int get_total_number_of_sectors(){
	int spc = 0, tnumclus = 0;
	__asm{
	mov AH, 36h								// get disk free space function
	mov DL, 01h								// drive a: = 1
	int 21h									// call interrupt
	mov WORD PTR spc, AX					// sectors per cluster
	mov WORD PTR tnumclus, DX			// total number of clusters
	}return spc*tnumclus;}

// ***************************** MAIN PROGRAM ***************************
void main(){
 
// DECLARE VARIABLES
	unsigned char buffer[512];
	int HANDLE, sector_number, sector_number_w, sec_per_clus, num_sec, test_file = 0, test_disk = 0, test_exit = 0;
	char huh, filename_w[60], filename_r[60], invert_file[] = "xyzabc";
	FILE *fptr, *fin, *fout;
	unsigned char buffy[512];
	fpos_t filepos_r, filepos_w;
	long fpc;

// VIDEO
	position_cursor(0,0);
	set_color(0x001D);

// EVALUATE DISK
	num_sec = get_total_number_of_sectors();
	sec_per_clus = get_sectors_per_cluster();
	printf("\n     Your Floppy Disk Has %d Sectors/Cluster At %d Sectors.", sec_per_clus, num_sec);
	if(sec_per_clus == 4) printf("\n     You Cannot Overwrite A Windows 95 Disk.");

// START BY GETTING INPUT
	printf("\n\n     YOU MUST BE IN MS_DOS MODE TO RUN THIS PROGRAM!\n\n     YOU WILL HAVE PROBLEMS IF YOU USE A MS_DOS WINDOW!\n\n     This program copies a 1.716224 megabyte DMF formatted\n     floppy.  Enter 'R' or 'r' to read the disk, and\n     save it to a file.  Or, enter 'W' or 'w' to write the\n     disk file copy to a 1.745408 megabyte formatted floppy.\n     The disk file can be copied to the larger floppy.  The\n     larger floppy has an extra track, which is ignored.  But,\n     the larger floppy has the necessary 21 sectors per track.\n\n     Progress of the copy of the 3360 sectors is displayed.\n\n     You will have to restart the computer and use\n     Windows to view the newly copied floppy.\n\n     Enter 'W', 'w', 'R', or 'r'.  All other keys exit: ");
	huh = getc(stdin);
	if(huh == 'R' || huh == 'r') goto reader;
	if(huh == 'W' || huh == 'w') goto writer;
	if(huh != 'R' && huh != 'r' && huh != 'W' && huh != 'w') {
		test_exit = 1;
		goto ender;}

// READ DISK
reader:;
	if((huh == 'R' || huh == 'r') && (num_sec < 3300 || num_sec > 3400)){
		test_disk = 1;
		goto ender;}
  
// GET NAME OF FILE FOR DISK IMAGE
    printf("\n\n\tEnter name of file to hold disk image from floppy: ");
    fflush(stdin);
    scanf("%s", &filename_w);
    printf("\n\n\tYou will store the disk image to file %s.\n\n", filename_w);

// CREATE DISKFILE
	__asm{
		mov AH, 3Ch								// create file function
		mov CX, 00h								// file attribute is read only
		LEA DX, invert_file	   		    		// DS:DX
		int 21h									// interrupt call
		mov WORD PTR HANDLE, AX			     	// save handle
		}

// START OF READ DISK SECTORS ONLY TO WRITE SECTORS TO FILE LOOP
	printf("\n\n");
	for(sector_number = 3359; sector_number >= 0; sector_number--){
	sector_number_w = 3359 - sector_number;
	fprintf(stderr,"               Reading sector %d.  \r  ", sector_number);

// READ SECTORS FROM DISK
	__asm{
		mov AL, 00h            				// drive A:
		LEA BX, buffer               		// ES:BX
		mov CX, 01h                      // number of sectors to read
		mov DX, sector_number        		// sector
		int 25h
// SET WRITE FILE POINTER
		mov DX, 00h                                                             // empty DX
		mov CX, 00h								// empty CX
		mov AX, 512                                                             // size of buffer AX = 512
		mul sector_number_w	// AX,DX = AX * counters = 512 * counters
		mov CX, DX      		// CX has low part of 32 bit value of file pointer
		mov DX, AX      		// DX has high part of 32 bit value of file pointer
		mov BX, WORD PTR HANDLE				// file handle
		mov AL, 00h				// pointer is offset from beginning location
		mov AH, 42h								// set pointer function
		int 21h									// interrupt call
// WRITE SECTORS TO FILE
		mov BX, WORD PTR HANDLE				// file handle
		mov AH, 40h								// write to file function
		mov CX, 512								// # of bytes to write
		LEA DX, buffer               		// DS:DX
		int 21h}

// END OF READ DISK SECTORS ONLY TO WRITE SECTORS TO FILE LOOP
	}

// CLOSE FILE
	__asm{
		mov BX, WORD PTR HANDLE				// handle of disk file
		mov ah, 3eh								// close file function
		int 21h}

// INVERT FILE
	fin = fopen(invert_file,"rb");
	fout = fopen(filename_w,"w+b");
	for(fpc = 3359; fpc >= 0; fpc--){
	filepos_r = fpc * 512;
	fsetpos(fin, &filepos_r);
	fread(buffy, 1, 512, fin);
// DISPLAY
	fprintf(stderr,"               File inversion by sector # %d.  \r  ", fpc);
	filepos_w = (3359 - fpc) * 512;
	fsetpos(fout, &filepos_w);
	fwrite(buffy, 1, 512, fout);}
// CLOSE FILES
	fclose(fin);
	fclose(fout);

writer:;
// IF YOU ARE READING YOU ARE NOT WRITING
	if(huh == 'R' || huh == 'r') {
	test_disk = 3;
	goto ender;}

// IF DISK IS NOT THE RIGHT SIZE SKIP
	if((huh == 'W' || huh == 'w') && num_sec < 3300){
		test_disk = 1;
		goto ender;}
  
// GET NAME OF FILE TO READ DISK IMAGE FROM
    printf("\n\n\tEnter name of file to read disk image to floppy: ");
    fflush(stdin);
    scanf("%s", &filename_r);
    printf("\n\n\tYou will read the disk image from file %s.\n\n", filename_r);

// IF FILE DOES NOT EXIST SKIP
	if((fptr = fopen(filename_r, "r")) == NULL){
		test_file = 1;
		fclose(fptr);
		goto ender;}

// IF DISK TO BE OVERWRITTEN IS WINDOWS 95 SKIP
	if((huh == 'W' || huh == 'w') && sec_per_clus == 4){
		test_disk = 2;
		goto ender;}

// OPEN DISK FILE
	__asm{
		mov AH, 3Dh								// open file function
		mov AL, 02h								// access mode read and write
		mov CX, 00h								// file attribute is read only
		LEA DX, filename_r             	    	// DS:DX
		int 21h									// interrupt call
		mov WORD PTR HANDLE, AX			    	// save handle
		}

// START OF READ FILE WRITE SECTORS TO DISK LOOP
	printf("\n\n");
	for(sector_number = 3359; sector_number >= 0; sector_number--){
	fprintf(stderr,"               Writing sector %d.  \r  ", sector_number);

// SET READ FILE POINTER
	__asm{
		mov DX, 00h								// empty DX
		mov CX, 00h								// empty CX
		mov AX, 512								// size of buffer AX = 512
		mul sector_number // AX,DX = AX * counters = 512 * counters
		mov CX, DX			// CX has low part of 32 bit value of file pointer
		mov DX, AX			// DX has high part of 32 bit value of file pointer
		mov BX, WORD PTR HANDLE				// file handle
		mov AL, 00h			// pointer is offset from begining location
		mov AH, 42h								// set pointer function
		int 21h									// interrupt call
// READ FILE SECTOR BY SECTOR
		mov BX, WORD PTR HANDLE          // file handle
		mov AH, 3Fh                      // read file function
		mov CX, 512   							// number of bytes to read
		LEA DX, buffer           			// DS:DX
		int 21h
// WRITE SECTORS TO DISK
		mov AL, 00h            				// drive A:
		LEA BX, buffer               		// ES:BX
		mov CX, 01h                      // number of sectors to write
		mov DX, sector_number        		// sector
		int 26h}

// END OF READ FILE WRITE SECTORS TO DISK LOOP
	}

// CLOSE FILE
	__asm{
		mov BX, WORD PTR HANDLE          // handle of disk file
		mov ah, 3Eh								// close file function
		int 21h}

// END
	test_disk = 4;
ender:;

// RESTORE SCREEN
	position_cursor(10,0);
	set_color(0x000F);
	if(test_file == 1)printf("\n\n     The file %s was not found.\n\n     There is nothing to copy from.", filename_r);
	if(test_disk == 1)printf("\n\n     The disk is not the right size.\n\n     This program only copies a disk of 3360 sectors\n     to a disk of at least 80 tracks on two sides\n     each with 21 sectors per track.");
	if(test_exit == 1)printf("\n\n     You chose to do nothing.\n\n");
	if(test_disk == 2)printf("\n\n     You cannot overwrite a Windows 95 disk.\n\n     You would have to format it first.");
	if((huh == 'R' || huh == 'r') && test_disk == 3) printf("\n\n     You read the DMF floppy disk to the file %s.\n\n", filename_w);
    if((huh == 'W' || huh == 'w') && test_disk == 4) printf("\n\n     You wrote the disk file %s to floppy a:\\.\n     You must go to Windows to view the newly copied\n     disk.  You cannot view it in MS_DOS mode.", filename_r);

// DELETE INVERT FILE
    __asm{
        mov AH, 41h                             // delete file function  
		LEA DX, invert_file             	    // DS:DX
		int 21h}								// call interrupt  
    
	printf("\n\n     Freehafer's DMF Disk Copy Program Is Terminated!\n\n     (c)2002 INNIEA PUBLISHING COMPANY  R%c%cK NOG!\n\n",(char)153,(char)142);}


